
#ifndef _MCAL_FUNC__
#define _MCAL_FUNC__

#include "stdafx.h"
#include "visa.h"


#define PROBLEM_317_01_a	// SinZero and SinTwoV move out of Self-Cal
#ifdef PROBLEM_317_01_a
	#define AC_AMP_EXT_COUNT		4
#else
	#define AC_AMP_EXT_COUNT		0
#endif

#define FlatnessStepStart			(24)

enum CalSetup
{
	CS_SELF_TEST = 0,
	CS_FREQ,
	CS_ADC,
	CS_SELF_CAL,
	CS_AC_AMP,
	// 5
	CS_FLTNS_0DBM,
	CS_FLTNS_10DBM,
	CS_FLTNS_20DBM,

	CS_TOTAL
};

typedef struct _tagCAL_SETUP
{
	int			nStep;
	LPCSTR		sTitle;

	LPCSTR		sChangeTip;

	int			nTestCount;
	void		(*MeterInit)(ViSession vi);
	ViStatus	(*MeterMeas)(ViSession vi, double *value, double dParm = 0.0);
	double		*MeterExtParm;
}tagCAL_SETUP;


class CManualAdj
{
public:
	CManualAdj(HWND &m_hWnd);
	virtual ~CManualAdj();

	BOOL	OpenINSTR_Meter(LPSTR addr);
	BOOL	OpenINSTR_AWG(LPSTR addr);
	void	CloseINSTR_Meter();
	void	CloseINSTR_AWG();

	BOOL	IsErr();
	BOOL	IsErrorAndDisp();
	BOOL	IsSecuredAWG();

	void	InitEquipState();	// Meter and AWG
	void	CalPowerSensor();
	void	UnSecuredAWG(LPCSTR psswrd);

	void	GetCurSetupTitle(LPSTR lpText);
	void	GetCalErrMsg(CString &csErr);

	void	SetCalSetup(enum CalSetup step, BOOL bInit = TRUE);
	void	SetSecureAWG(LPCSTR psswrd);

	BOOL	CalExecute();		// 0:NG, 1:OK


protected:
	HWND *m_pExtWnd;

	ViStatus status;
	ViSession defRM;
	ViSession viMeter, viAWG;

	tagCAL_SETUP *GetCurCalSetup() const;
};


extern void MySleep(DWORD dwMS);

#endif	/*  _MCAL_FUNC__ */