// ManualAdjustmentDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ManualAdjustment.h"
#include "ManualAdjustmentDlg.h"
#include "MCal_Func.h"
#include "PassWordDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
#define cntDIM(x)					(sizeof(x)/sizeof(x[0]))

#define ID_CAL_CLICK_UPPER			IDC_CHK_CAL_8
#define ID_CAL_CLICK_LOWER			IDC_CHK_CAL_1


typedef struct _CalDlgItm
{
	int		nStep;

	UINT	idClick;
	UINT	idPic;

	char	sText[128];
}tagCalDlgItm;

const tagCalDlgItm CalControl[] =
{
	{ CS_SELF_TEST,		IDC_CHK_CAL_1,	IDC_PIC_1,	_T("")	},
	{ CS_FREQ,			IDC_CHK_CAL_2,	IDC_PIC_2,	_T("")	},
	{ CS_ADC,			IDC_CHK_CAL_3,	IDC_PIC_3,	_T("")	},
	{ CS_SELF_CAL,		IDC_CHK_CAL_4,	IDC_PIC_4,	_T("")	},
	{ CS_AC_AMP,		IDC_CHK_CAL_5,	IDC_PIC_5,	_T("")	},
	// 5
	{ CS_FLTNS_0DBM,	IDC_CHK_CAL_6,	IDC_PIC_6,	_T("")	},
	{ CS_FLTNS_10DBM,	IDC_CHK_CAL_7,	IDC_PIC_7,	_T("")	},
	{ CS_FLTNS_20DBM,	IDC_CHK_CAL_8,	IDC_PIC_8,	_T("")	}
};


enum CalInstrPos
{
	CIP_AWG = 0,
	CIP_COUNTER,
	CIP_MULTIMETER,
	CIP_POWERMETER,

	CIP_TOTAL
};

const char *strINSTR[] =
{
	"AWG",	"53132A",	"3458A",	"E4418B"
};

tagCalDlgItm CalMeter[] =
{
	{ 0,	IDC_EDT_AWG,		IDC_PIC_AWG,		"USB0::0x164E::0x13EC::?*::INSTR"	},	// AWG
	{ 0,	IDC_EDT_METER_1,	IDC_PIC_METER_1,	"GPIB0::3::INSTR"	},	// Counter
	{ 0,	IDC_EDT_METER_2,	IDC_PIC_METER_2,	"GPIB0::22::INSTR"	},	// MultiMeter
	{ 0,	IDC_EDT_METER_3,	IDC_PIC_METER_3,	"GPIB0::13::INSTR"	}	// Power Meter
};


CBitmap bmpNULL, bmpOK, bmpNG;

/////////////////////////////////////////////////////////////////////////////
// CManualAdjustmentDlg dialog

CManualAdjustmentDlg::CManualAdjustmentDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CManualAdjustmentDlg::IDD, pParent) , CManualAdj(CManualAdjustmentDlg::m_hWnd)
{
	//{{AFX_DATA_INIT(CManualAdjustmentDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	sAwgAdr[0] = '\0';
}

void CManualAdjustmentDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManualAdjustmentDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CManualAdjustmentDlg, CDialog)
	//{{AFX_MSG_MAP(CManualAdjustmentDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CONTROL_RANGE(BN_CLICKED, ID_CAL_CLICK_LOWER, ID_CAL_CLICK_UPPER, OnDynamicSelect)
	ON_BN_CLICKED(IDC_BTN_Begin, OnBTNBegin)
	ON_BN_CLICKED(IDC_CHK_CAL_ALL, OnChkCalAll)
	ON_BN_CLICKED(IDC_CHK_ADDR, OnChkAddr)
	ON_EN_CHANGE(IDC_EDT_AWG, OnChangeEdt)
	ON_BN_CLICKED(IDC_BTN_SCANINSTR, OnBtnScaninstr)
	ON_WM_SHOWWINDOW()
	ON_EN_CHANGE(IDC_EDT_METER_1, OnChangeEdt)
	ON_EN_CHANGE(IDC_EDT_METER_2, OnChangeEdt)
	ON_EN_CHANGE(IDC_EDT_METER_3, OnChangeEdt)
	ON_BN_CLICKED(IDC_BTN_PwrSnr_ZeroCal, OnBTNPwrSnrZeroCal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManualAdjustmentDlg message handlers

BOOL CManualAdjustmentDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	bmpOK.LoadBitmap(IDB_OK);
	bmpNG.LoadBitmap(IDB_NG);
	bmpNULL.LoadBitmap(IDB_NULL);

	CEdit *pEdit;
	fntINSTR.CreatePointFont(11*10, "Arial");

	GetDlgItem(IDC_CHK_ADDR)->SetFont(&fntINSTR);
	GetDlgItem(IDC_CHC_AWG_SEC)->SetFont(&fntINSTR);
	GetDlgItem(IDC_BTN_PwrSnr_ZeroCal)->SetFont(&fntINSTR);
	for(int i=0; i<CIP_TOTAL; i++)
	{
		pEdit = (CEdit *)GetDlgItem(CalMeter[i].idClick);
		pEdit->SetFont(&fntINSTR);
		pEdit->SetLimitText(127);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CManualAdjustmentDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CManualAdjustmentDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CManualAdjustmentDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	static BOOL bInit = FALSE;
	if(!bInit && bShow)
	{
		bInit = TRUE;
		((CButton *)GetDlgItem(IDC_CHK_CAL_ALL))->SetCheck(BST_CHECKED);

	#ifndef _DEBUG
		((CButton *)GetDlgItem(IDC_CHC_AWG_SEC))->SetCheck(BST_CHECKED);
	#endif

		OnChkCalAll();
		OnChkAddr();
	}
}

void CManualAdjustmentDlg::OnDynamicSelect(UINT id)
{
	int selall, nSetup;

	for(nSetup=0; nSetup < CS_TOTAL; nSetup++)
	{
		selall = IsCalSelect(nSetup);
		switch(selall)
		{
			case -1:	// Over Range
			case 0:		// UnClick
				((CButton *)GetDlgItem(IDC_CHK_CAL_ALL))->SetCheck(BST_UNCHECKED);
				return;

		}
	}
	((CButton *)GetDlgItem(IDC_CHK_CAL_ALL))->SetCheck(BST_CHECKED);
}

void CManualAdjustmentDlg::OnChangeEdt() 
{
	UINT ID = this->GetFocus()->GetDlgCtrlID();
	CString csBuf;

	GetDlgItemText(ID, csBuf);
	if(csBuf.GetLength() > 127)
	{
		AfxMessageBox("String too long !", MB_ICONSTOP);
		return;
	}

	for(int i=0; i<CIP_TOTAL; i++)
	{
		if(CalMeter[i].idClick == ID)
		{
			((CStatic *)GetDlgItem(CalMeter[i].idPic))->SetBitmap(bmpNULL);
			strcpy(CalMeter[i].sText, csBuf.GetBuffer(0));
			return;
		}
	}
}

void CManualAdjustmentDlg::OnChkCalAll() 
{
	int state = ((CButton *)GetDlgItem(IDC_CHK_CAL_ALL))->GetCheck();

	for(int i=0; i<CS_TOTAL; i++)
	{
		((CButton *)GetDlgItem(CalControl[i].idClick))->SetCheck(state);
	}
}

void CManualAdjustmentDlg::OnChkAddr() 
{
//	CButton *pBtn;
//	DWORD dwStyle = WS_BORDER;
	int i,
		state = ((CButton *)GetDlgItem(IDC_CHK_ADDR))->GetCheck();

	for(i=0; i<CIP_TOTAL; i++)
	{
//		pBtn = ((CButton *)GetDlgItem(CalMeter[i].idClick));

		if(state == BST_CHECKED)
		{
			//pBtn->ModifyStyle(dwStyle, 0, SWP_FRAMECHANGED);
			((CEdit *)GetDlgItem(CalMeter[i].idClick))->SetReadOnly(FALSE);
			SetDlgItemText(CalMeter[i].idClick, CalMeter[i].sText);
		}
		else
		{
			//pBtn->ModifyStyle(0, dwStyle, SWP_FRAMECHANGED);
			((CEdit *)GetDlgItem(CalMeter[i].idClick))->SetReadOnly();
			SetDlgItemText(CalMeter[i].idClick, strINSTR[i]);
		}

	}

}

void CManualAdjustmentDlg::OnOK()
{
	OnBTNBegin();
}

void CManualAdjustmentDlg::OnCancel()
{
	CDialog::OnCancel();
}

int CManualAdjustmentDlg::IsCalSelect(int nStep)
{
	if(nStep < 0 || nStep >= CS_TOTAL)
		return -1;	// Setup over range

	if( ((CButton *)GetDlgItem(CalControl[nStep].idClick))->GetCheck() == BST_CHECKED )
		return 1;	// Click
	else
		return 0;	// UnClick
}

void CManualAdjustmentDlg::OnBTNBegin() 
{
	int nSetup;
	BOOL bChk;
	CButton *pBtn;
	DWORD dwBtnStyle = WS_EX_DLGMODALFRAME;
	CString csErr;
	PassWordDlg dlg;


	OnBtnScaninstr();
	LockAll(FALSE);

	// Reset all visual effects 
	for(nSetup=0; nSetup < CS_TOTAL; nSetup++)
	{
		((CStatic *)GetDlgItem(CalControl[nSetup].idPic))->SetBitmap(bmpNULL);
		pBtn = ((CButton *)GetDlgItem(CalControl[nSetup].idClick));
		pBtn->ModifyStyleEx(dwBtnStyle, 0, SWP_FRAMECHANGED);
	}

	// Connect to AWG
	if(OpenINSTR_AWG(sAwgAdr))
	{
		AfxMessageBox("Connect to AWG fail !", MB_ICONSTOP);
		goto ERROR_END;
	}

	// Unsecured AWG for calibration
	viPrintf(viAWG, "*CLS\n");
	if(IsSecuredAWG())
	{
		while(1)
		{
			SetForegroundWindow();
			if(dlg.DoModal() == IDOK)
				UnSecuredAWG(dlg.m_sPassWord.GetBuffer(0));
			else
				goto ERROR_END;

			GetCalErrMsg(csErr);
			if(csErr.GetLength() < 1)
				break;
			else
			{
				if(IDRETRY != MessageBox(csErr, "Error Occurred, Retry ? ", MB_ICONSTOP | MB_RETRYCANCEL))
					goto ERROR_END;
			}

		}
	}

	for(nSetup=0; nSetup < CS_TOTAL; nSetup++)
	{
		if(IsCalSelect(nSetup) != 1) continue;

		pBtn = ((CButton *)GetDlgItem(CalControl[nSetup].idClick));
		pBtn->ModifyStyleEx(0, dwBtnStyle, SWP_FRAMECHANGED);
		MySleep(1);	// Transmission system message

		// Connect to Meter
		bChk = FALSE;
		switch(nSetup)
		{
			case CS_FREQ:
				bChk = OpenINSTR_Meter(CalMeter[CIP_COUNTER].sText);
				break;

			case CS_ADC:
			case CS_AC_AMP:
				bChk = OpenINSTR_Meter(CalMeter[CIP_MULTIMETER].sText);
				break;

			case CS_FLTNS_0DBM:
			case CS_FLTNS_10DBM:
			case CS_FLTNS_20DBM:
				bChk = OpenINSTR_Meter(CalMeter[CIP_POWERMETER].sText);
				break;
		}
		if(bChk)
			goto ERROR_END;	// Abort

		SetCalSetup( (enum CalSetup)nSetup );
		if(!CalExecute())
		{
			// NG icon
			((CStatic *)GetDlgItem(CalControl[nSetup].idPic))->SetBitmap(bmpNG);
			goto ERROR_END;
		}
		else
		{
			// OK icon
			((CStatic *)GetDlgItem(CalControl[nSetup].idPic))->SetBitmap(bmpOK);
		}

		pBtn->ModifyStyleEx(dwBtnStyle, 0, SWP_FRAMECHANGED);
	}

	// Secure AWG for calibration
	if( ((CButton *)GetDlgItem(IDC_CHC_AWG_SEC))->GetCheck() == BST_CHECKED )
	{
		if(dlg.m_sPassWord.GetLength() < 1)
		{
			SetForegroundWindow();
			if(dlg.DoModal() == IDOK)
				SetSecureAWG(dlg.m_sPassWord.GetBuffer(0));
			else
				AfxMessageBox("User cancel, the AWG is unsecured !", MB_ICONWARNING);
		}
		else
			SetSecureAWG(dlg.m_sPassWord.GetBuffer(0));
	}

ERROR_END:
	CloseINSTR_Meter();
	CloseINSTR_AWG();
	LockAll(TRUE);
}

void CManualAdjustmentDlg::OnBtnScaninstr() 
{
	int btn_state = ((CButton *)GetDlgItem(IDC_CHK_ADDR))->GetCheck();
	unsigned long retCnt;
	ViFindList find_list;

	// AWG
	status = viFindRsrc(defRM, CalMeter[CIP_AWG].sText, &find_list, &retCnt, sAwgAdr);
	if(status == VI_SUCCESS)
	{
		char sSN[64], sModel[128], sBuf[128];
		int i;

		status = viOpen(defRM, sAwgAdr, VI_NULL, VI_NULL, &viAWG);
		((CStatic *)GetDlgItem(CalMeter[CIP_AWG].idPic))->SetBitmap( ((status == VI_SUCCESS)? bmpOK: bmpNG) );

		if(btn_state != BST_CHECKED)
		{
			viGetAttribute(viAWG, VI_ATTR_USB_SERIAL_NUM, sSN);	// Get AWG SN
			viGetAttribute(viAWG, VI_ATTR_MODEL_NAME, sModel);	// Get AWG Model Name

			for(i=0; sModel[i] != ' ' && sModel[i] != 0; i++)
				sBuf[i] = sModel[i];

			sBuf[i++] = '\0';
			strcat(sBuf, " - ");
			strcat(sBuf, sSN);
			SetDlgItemText(CalMeter[CIP_AWG].idClick, sBuf);
		}

		viClose(viAWG);
		viAWG = 0;

		if(status != VI_SUCCESS)
			sAwgAdr[0] = '\0';
	}
	else
	{
		((CStatic *)GetDlgItem(CalMeter[CIP_AWG].idPic))->SetBitmap(bmpNG);
		if(btn_state != BST_CHECKED)
			SetDlgItemText(CalMeter[CIP_AWG].idClick, strINSTR[CIP_AWG]);

		sAwgAdr[0] = '\0';
	}

	// Counter
	status = viOpen(defRM, CalMeter[CIP_COUNTER].sText, VI_NULL, VI_NULL, &viMeter);
	((CStatic *)GetDlgItem(CalMeter[CIP_COUNTER].idPic))->SetBitmap( ((status == VI_SUCCESS)? bmpOK: bmpNG) );
	if(viMeter != 0)
	{
		viClose(viMeter);
		viMeter = 0;
	}

	// MultiMeter
	status = viOpen(defRM, CalMeter[CIP_MULTIMETER].sText, VI_NULL, VI_NULL, &viMeter);
	((CStatic *)GetDlgItem(CalMeter[CIP_MULTIMETER].idPic))->SetBitmap( ((status == VI_SUCCESS)? bmpOK: bmpNG) );
	if(viMeter != 0)
	{
		viClose(viMeter);
		viMeter = 0;
	}

	// Power Meter
	status = viOpen(defRM, CalMeter[CIP_POWERMETER].sText, VI_NULL, VI_NULL, &viMeter);
	((CStatic *)GetDlgItem(CalMeter[CIP_POWERMETER].idPic))->SetBitmap( ((status == VI_SUCCESS)? bmpOK: bmpNG) );
	if(viMeter != 0)
	{
		viClose(viMeter);
		viMeter = 0;
	}
}

void CManualAdjustmentDlg::OnBTNPwrSnrZeroCal() 
{
	LockAll(FALSE);

	if(OpenINSTR_Meter(CalMeter[CIP_POWERMETER].sText))
		AfxMessageBox("Connect to E4418B fail !", MB_ICONSTOP);
	else
	{
		SetForegroundWindow();
		if(IDYES == AfxMessageBox("Connect POWER SENSOR to E4418B POWER REF !", MB_ICONWARNING | MB_YESNO))
			CalPowerSensor();

		CloseINSTR_Meter();
	}

	LockAll(TRUE);
}

void CManualAdjustmentDlg::LockAll(BOOL blck)
{
	CMenu* pSysMenu = GetSystemMenu(FALSE);

	if(blck)
	{
		//GetDlgItem(IDC_CHK_ADDR)->EnableWindow(TRUE);
		GetDlgItem(IDC_BTN_SCANINSTR)->EnableWindow(TRUE);
		GetDlgItem(IDC_BTN_PwrSnr_ZeroCal)->EnableWindow(TRUE);
		GetDlgItem(IDC_BTN_Begin)->EnableWindow(TRUE);
		pSysMenu->EnableMenuItem(SC_CLOSE, MF_ENABLED);	// Enable System Menu Close button
	}
	else
	{
		//GetDlgItem(IDC_CHK_ADDR)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_SCANINSTR)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_PwrSnr_ZeroCal)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_Begin)->EnableWindow(FALSE);
		pSysMenu->EnableMenuItem(SC_CLOSE, MF_GRAYED);	// Disable System Menu Close button
	}
}
