// PassWordDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ManualAdjustment.h"
#include "PassWordDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PassWordDlg dialog


PassWordDlg::PassWordDlg(CWnd* pParent /*=NULL*/)
	: CDialog(PassWordDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(PassWordDlg)
	m_sPassWord = _T("");
	//}}AFX_DATA_INIT
}


void PassWordDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PassWordDlg)
	DDX_Text(pDX, IDC_EDT_PASSWORD, m_sPassWord);
	DDV_MaxChars(pDX, m_sPassWord, 12);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PassWordDlg, CDialog)
	//{{AFX_MSG_MAP(PassWordDlg)
	ON_EN_CHANGE(IDC_EDT_PASSWORD, OnChangeEdtPassword)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PassWordDlg message handlers

void PassWordDlg::OnChangeEdtPassword() 
{
	if(!UpdateData()) return;
	if(m_sPassWord.GetLength() < 1) return;
	
	m_sPassWord.MakeUpper();
	char s = m_sPassWord.GetAt(0);

	if(s < 'A' || s > 'Z')
	{
		AfxMessageBox("The first character must be a letter (A-Z) !", MB_ICONSTOP);
		m_sPassWord.Empty();
		UpdateData(FALSE);
		return;
	}
}

void PassWordDlg::OnOK()
{
	if(!UpdateData()) return;

	m_sPassWord.TrimLeft();
	if(m_sPassWord.GetLength() < 1)
	{
		AfxMessageBox("Password can't be empty !", MB_ICONSTOP);
		GetDlgItem(IDC_EDT_PASSWORD)->SetFocus();
		((CEdit *)GetDlgItem(IDC_EDT_PASSWORD))->SetSel(0, -1);
		return;
	}
	else
		CDialog::OnOK();
}